"""
Migration utility. Applies table changes to database
"""

import os

from tionix_client.helpers.i18 import ugettext as _
from tionix_client.db.sqlalchemy.migration import migrate


def main(migration=None, verbose=False):
    if migration:
        try:
            migration = int(migration)
        except ValueError:
            return os.EX_SOFTWARE, _(u'Invalid migration version: {0}').format(
                migration)
    try:
        return migrate(version=migration)
    except Exception as ex:
        if verbose:
            msg = _(u'Error while db migrate: {0}').format(unicode(ex))
        else:
            msg = _(u'Unknown DB Error. Please contact your administrator.')
        return os.EX_SOFTWARE, msg
