# coding: utf-8
import argparse

from tionix_client.helpers.general import hidden_traceback

from tionix_client.log import setup_logging
from tionix_client.journal.worker import start_worker, Service


def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('--service', choices=Service.items)
    parsed_args = parser.parse_args()
    return parsed_args


if __name__ == '__main__':
    setup_logging()
    with hidden_traceback():
        args = parse_args()
        start_worker(args.service)
