# coding: utf-8

from sqlalchemy import (
    MetaData, String, Table, Column, Integer, Enum, UnicodeText, Boolean,
    DateTime)


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    journal = Table(
        'journal', meta,
        Column('id', Integer, primary_key=True, nullable=False),
        Column('object_id', String(64), nullable=False),
        Column('object_type', String(64), nullable=False),
        Column('action', String(64), nullable=False),
        Column(
            'status', Enum('success', 'failure', 'unknown'), nullable=False),
        Column('event_time', DateTime, nullable=False),
        Column('is_notification', Boolean, nullable=False),
        Column('action_arguments', UnicodeText(), nullable=True),
        Column('response_code', String(64), nullable=True),
        Column('message', UnicodeText(), nullable=True),
        Column('user_id', String(64), nullable=True),
        Column('user_name', String(64), nullable=True),
        Column('request_id', String(64), nullable=True),
        Column('parent_request_id', String(64), nullable=True),
        mysql_charset='utf8'
    )
    journal.create()


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    journal = Table('journal', meta, autoload=True)
    journal.drop()
