# coding: utf-8
# pylint: disable=no-value-for-parameter,no-member

from sqlalchemy import (
    MetaData, String, Table, Column, Integer, Enum, UnicodeText, Boolean,
    DateTime)


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    shadow_journal = Table(
        'shadow_journal', meta,
        Column('id', Integer, primary_key=True, nullable=False),
        Column('object_id', String(64), nullable=False),
        Column('object_type', String(64), nullable=False),
        Column('action', String(64), nullable=False),
        Column(
            'status', Enum('success', 'failure', 'unknown'), nullable=False),
        Column('event_time', DateTime, nullable=False),
        Column('is_notification', Boolean, nullable=False),
        Column('action_arguments', UnicodeText()),
        Column('response_code', String(64)),
        Column('message', UnicodeText()),
        Column('user_id', String(64)),
        Column('user_name', String(64)),
        Column('request_id', String(64)),
        Column('parent_request_id', String(64)),
        Column('domain_id', String(64)),
        mysql_charset='utf8'
    )
    shadow_journal.create()


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    journal = Table('shadow_journal', meta, autoload=True)
    journal.drop()
