import yaml

from tionix_client.settings import CONFIG_PATH, Config
from tionix_client.settings import validators as client_validators


validators_map = dict(**client_validators.validators_map)
validators_map.update({
    'ENGINE': client_validators.get_valid_db_engine,
    'PORT': client_validators.get_valid_port,
    'broker_type': client_validators.get_valid_broker_type,
    'port': client_validators.get_valid_port,
})


def read_default_settings():
    with open(CONFIG_PATH) as fh:
        base_config = yaml.safe_load(fh)
    return base_config


def get_general_config():
    return Config(
        config_files=[CONFIG_PATH],
        default_settings=read_default_settings(),
        validators=validators_map,
        immutable_variables=[],
        unused_variables=[])
