# coding: utf-8


class PACKAGES(object):

    TIONIX_CC = u'TIONIX.CloudControl'
    TIONIX_Dashboard = u'TIONIX.Dashboard'
    TIONIX_Monitor = u'TIONIX.Monitor'
    TIONIX_NC = u'TIONIX.NodeControl'
    TIONIX_Scheduler = u'TIONIX.Scheduler'
    TIONIX_VDIServer = u'TIONIX.VDIserver'
    TIONIX_SchedulerClient = u'TIONIX.SchedulerClient'
    TIONIX_Client = u'TIONIX.Client'
    TIONIX_VDIClient = u'TIONIX.VDIclient'

    pip_names = {
        TIONIX_CC: 'tionix-cloud-control',
        TIONIX_Dashboard: 'tionix-dashboard',
        TIONIX_Monitor: 'tionix-monitor',
        TIONIX_NC: 'tionix-node-control',
        TIONIX_Scheduler: 'tionix-scheduler',
        TIONIX_VDIServer: 'tionix-vdi-server',
        TIONIX_VDIClient: 'tionix-vdi-client',
        TIONIX_SchedulerClient: 'tionix-scheduler-client',
        TIONIX_Client: 'tionix-client',
    }

    extension_names = {
        TIONIX_CC: 'tnx-cloud-control',
        TIONIX_Monitor: 'tnx-monitor',
        TIONIX_NC: 'tnx-node-control',
        TIONIX_VDIServer: 'tnx-vdi-server',
    }


class TnxFieldMixin(object):
    """
    Mixin for tnx classes inherited from novaclient resources classes that have
     __getattr__ method.
    If any requested field with 'tnx_' prefix isn't defined None value returns.
    In any other case behaviour is the same as defined in novaclient
    base.Resource class.
    """
    def __getattr__(self, item):
        if item.startswith('tnx_') and self.is_loaded():
            return self.__dict__.get(item, None)
        return super(TnxFieldMixin, self).__getattr__(item)
