# coding: utf-8

"""
Journal model
"""


from sqlalchemy import Column, String, UnicodeText, DateTime, Boolean, Enum

from tionix_client.core.models import BaseModel
from tionix_client.journal.constants import ActionStatus


class Journal(BaseModel):
    """Journal model"""

    __tablename__ = 'journal'

    object_id = Column('object_id', String(64), nullable=False)
    object_type = Column('object_type', String(64), nullable=False)
    action = Column('action', String(64), nullable=False)
    status = Column('status', Enum(ActionStatus.TYPES), nullable=False)
    event_time = Column('event_time', DateTime, nullable=False)
    is_notification = Column('is_notification', Boolean, nullable=False)
    action_arguments = Column('action_arguments', UnicodeText(), nullable=True)
    response_code = Column('response_code', String(64), nullable=True)
    message = Column('message', UnicodeText(), nullable=True)
    user_id = Column('user_id', String(64), nullable=True)
    user_name = Column('user_name', String(64), nullable=True)
    request_id = Column('request_id', String(64), nullable=True)
    parent_request_id = Column('parent_request_id', String(64), nullable=True)
