# coding: utf-8

from cliff import lister

from tionix_client.helpers.packages_info import get_modules_info_data
from tionix_client.os_clients.nova_client import get_nova_client
from tionix_client.osc.helpers import get_osc_opts


class ListModules(lister.Lister):
    """
    Show the TIONIX modules info.
    """

    auth_required = False

    def take_action(self, parsed_args):
        connect_opts = get_osc_opts(self.app.options)
        nova_cl = get_nova_client(**connect_opts)
        return get_modules_info_data(nova_cl)
