# coding: utf-8

import unittest

from collections import Counter

from tionix_client.functional import DetailedTestRunner
from tionix_client.functional.helpers import TestResultStatus


class BaseRunnerTestCase(unittest.TestCase):
    """Base test case for testing functional tests runner"""

    class SampleTestCase(unittest.TestCase):
        def test_ok(self):
            pass

        @staticmethod
        def test_error():
            raise IndexError

        def test_fail(self):
            self.fail(u'This test failed кириллица')

        @unittest.skip(u'unicode reason кириллица')
        def test_skipped_decorator(self):
            pass

        def test_skipped(self):
            self.skipTest(u'unicode reason кириллица')

    def execute_runner(self):
        test_suit = unittest.TestLoader().loadTestsFromTestCase(
            self.SampleTestCase)
        return DetailedTestRunner().run(test_suit)

    def get_expected_results(self):
        result_counter = Counter()
        for attr in self.SampleTestCase.__dict__:
            if callable(getattr(self.SampleTestCase, attr)):
                for status in TestResultStatus.map:
                    if status.lower() in attr:
                        result_counter[status] += 1
        return result_counter
