# coding: utf-8
import mock

from tionix_client.tests.helpers import BaseRunnerTestCase
from tionix_client.functional import TestParser
from tionix_client.functional.helpers import TestResultStatus


class ParserTestCase(BaseRunnerTestCase):
    """Case for testing TestsParser"""

    @mock.patch('tionix_client.functional.settings.read_default_settings',
                new=mock.Mock(return_value={}))
    def test_parser(self):
        runner_result = self.execute_runner().to_dict()
        expected_results = self.get_expected_results()

        test_parser = TestParser()
        test_parser.process_result(runner_result, 'Test')

        self.assertEqual(
            test_parser.total_result.error,
            expected_results[TestResultStatus.ERROR])
        self.assertEqual(
            test_parser.total_result.fail,
            expected_results[TestResultStatus.FAIL])
        self.assertEqual(
            test_parser.total_result.skipped,
            expected_results[TestResultStatus.SKIPPED])
