# coding: utf-8

import operator

from tionix_client.tests.helpers import BaseRunnerTestCase
from tionix_client.functional.helpers import TestResultStatus


class DetailedRunnerTestCase(BaseRunnerTestCase):
    """Case for testing DetailedTestRunner and DetailedTestResult"""

    def test_runner(self):
        runner_result = self.execute_runner().to_dict()
        expected_results = self.get_expected_results()

        total_count = reduce(operator.add, expected_results.values())

        for status in TestResultStatus.map:
            tests_count = len(
                runner_result['tests'][TestResultStatus.map[status]])
            self.assertEqual(
                tests_count, expected_results[status],
                u"Expected {0} tests to be in '{1}' status, found {2}".format(
                    expected_results[status], status, tests_count))

        self.assertEqual(runner_result['tests_run'], total_count)
        self.assertEqual(runner_result['was_successful'], False)
