# coding: utf-8

import unittest

from tionix_client.helpers.table import build_wrapped_table


class TableTestCase(unittest.TestCase):
    def test_build_wrapped_table(self):
        headers = [u'long header ' * 5, u'Column 2', u'Column 3']
        rows = [
            [u'1', u'test string 1', u'short string'],
            [u'2', u'test string 2', u'long string ' * 10],
            [u'3', u'test string 3', u'short string'],
            [u'4', u'test empty', ''],
            [u'5', u'test None', None],
        ]
        max_table_width = 40
        table = build_wrapped_table(headers, rows, max_table_width)
        table_width = len(table.splitlines()[0])
        self.assertLessEqual(table_width, max_table_width)
